<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: src/Ray.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_ray_8hpp_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Ray.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_ray_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * eduRayTracer - An Educational Ray Tracing Software Package</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Contributor(s): Pedro Santana - ISCTE-IUL (2014-2016)</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef _H_RAY_</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define _H_RAY_</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_vec_8hpp.html">Vec.hpp</a>&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="class_ray.html">   12</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_ray.html">Ray</a> {</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="class_ray.html#a167f59267ea3d32cb3a69f50ec13aeda">   16</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_ray.html#a167f59267ea3d32cb3a69f50ec13aeda">o</a>;</div><div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="class_ray.html#aa717ed3c35d27340583ddcc616df8c1b">   18</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_ray.html#aa717ed3c35d27340583ddcc616df8c1b">d</a>;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div><div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="class_ray.html#a28fc10d4a43d1a1e11111cee9f0ea2c0">   20</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_ray.html#a28fc10d4a43d1a1e11111cee9f0ea2c0">inv_d</a>;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno"><a class="line" href="class_ray.html#a96038ba150ebc0ab85c515cfb097c6cd">   28</a></span>&#160;    <a class="code" href="class_ray.html#a96038ba150ebc0ab85c515cfb097c6cd">Ray</a>(<a class="code" href="class_vec.html">Vec</a> _o, <a class="code" href="class_vec.html">Vec</a> _d) : o(_o), d(_d), inv_d(<a class="code" href="class_vec.html">Vec</a>(1,1,1).div(d)) {}</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    </div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="class_ray.html#a921c1b4282b604067d1e22de870c362d">   34</a></span>&#160;    <a class="code" href="class_vec.html">Vec</a> <a class="code" href="class_ray.html#a921c1b4282b604067d1e22de870c362d">tip_point</a>(<span class="keywordtype">double</span> t) { <span class="keywordflow">return</span> (o + d*t); }</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;};</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="class_ray_html_a96038ba150ebc0ab85c515cfb097c6cd"><div class="ttname"><a href="class_ray.html#a96038ba150ebc0ab85c515cfb097c6cd">Ray::Ray</a></div><div class="ttdeci">Ray(Vec _o, Vec _d)</div><div class="ttdoc">A Ray Constructor. A ray is defined as o + td, where o is the origin of the ray and d is the directio...</div><div class="ttdef"><b>Definition:</b> Ray.hpp:28</div></div>
<div class="ttc" id="class_ray_html_aa717ed3c35d27340583ddcc616df8c1b"><div class="ttname"><a href="class_ray.html#aa717ed3c35d27340583ddcc616df8c1b">Ray::d</a></div><div class="ttdeci">Vec d</div><div class="ttdoc">Rays&amp;#39;s direction vector. </div><div class="ttdef"><b>Definition:</b> Ray.hpp:18</div></div>
<div class="ttc" id="class_ray_html_a28fc10d4a43d1a1e11111cee9f0ea2c0"><div class="ttname"><a href="class_ray.html#a28fc10d4a43d1a1e11111cee9f0ea2c0">Ray::inv_d</a></div><div class="ttdeci">Vec inv_d</div><div class="ttdef"><b>Definition:</b> Ray.hpp:20</div></div>
<div class="ttc" id="class_ray_html_a167f59267ea3d32cb3a69f50ec13aeda"><div class="ttname"><a href="class_ray.html#a167f59267ea3d32cb3a69f50ec13aeda">Ray::o</a></div><div class="ttdeci">Vec o</div><div class="ttdoc">Ray&amp;#39;s origin vector. </div><div class="ttdef"><b>Definition:</b> Ray.hpp:16</div></div>
<div class="ttc" id="class_vec_html"><div class="ttname"><a href="class_vec.html">Vec</a></div><div class="ttdoc">A class to create and manipulate 3D vectors. These can be used to store positions, normals, and RGB triplets. </div><div class="ttdef"><b>Definition:</b> Vec.hpp:16</div></div>
<div class="ttc" id="_vec_8hpp_html"><div class="ttname"><a href="_vec_8hpp.html">Vec.hpp</a></div></div>
<div class="ttc" id="class_ray_html_a921c1b4282b604067d1e22de870c362d"><div class="ttname"><a href="class_ray.html#a921c1b4282b604067d1e22de870c362d">Ray::tip_point</a></div><div class="ttdeci">Vec tip_point(double t)</div><div class="ttdoc">Returns the point along the ray for a given t. </div><div class="ttdef"><b>Definition:</b> Ray.hpp:34</div></div>
<div class="ttc" id="class_ray_html"><div class="ttname"><a href="class_ray.html">Ray</a></div><div class="ttdoc">A class to create and manipulate 3D rays. </div><div class="ttdef"><b>Definition:</b> Ray.hpp:12</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="_ray_8hpp.html">Ray.hpp</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
